__MATH_INLINE double pow(double x, const double y)
{
        register double value, argy = y, exponent;

        long p=(long) y;
        if(x == 0.0 && y > 0.0) return 0.0;
        if(y == (double) p) {
                double r=1.0;
                if (p == 0) return 1.0;
                if (p < 0) {p = -p; x = 1.0/x;}
                for(;;) {
                        if (p & 1) r *= x;
                        if ((p >>= 1) == 0) return r;
                        x *= x;
                }
        }
        __asm__ __volatile__
                ("fmul  %%st(1)                 # y * log2(x)\n\t"
                 "fstl  %%st(1)\n\t"
                 "frndint                               # int(y * log2(x))\n\t"
                 "fxch\n\t"
                 "fsub  %%st(1)                 # fract(y * log2(x))\n\t"
                 "f2xm1                         # 2^(fract(y * log2(x))) - 1\n\t
"
                 : "=t" (value), "=u" (exponent) :  "0" (__log2(x)), "1" (argy))
;
        value += 1.0;
        __asm__ __volatile__
                ("fscale" : "=t" (value): "0" (value), "u" (exponent));
        return value;
}
